﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Dynamic;
using System.Collections;

namespace UltraGridBindToDynamicObject
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            // Bindinglist of ExpandoObject
            BindingList<ExpandoObject> viewList = new BindingList<ExpandoObject>();

            for (int i = 0; i < 50; i++)
            {
                // Create Dynamic object
                dynamic obj = new ExpandoObject();

                // Cretae dynamic properties
                obj.Item = "Test " + i.ToString();
                obj.Description = "Description " + i.ToString();
                obj.Comment = "Test N " + i.ToString();

                viewList.Add(obj);
            }

            var itemsList = from p in viewList
                            select new
                            {
                                // Define grid`s column 
                                Item = p.ElementAt(0).Value,
                                Description = p.ElementAt(1).Value,
                                Comment = p.ElementAt(2).Value
                            };

            ultraGrid1.DataSource = itemsList.ToList();
        }
    }
}
